.\" 
.\" To print out:
.\"	tbl TEST.tbl.ms | troff -ms - | lpr -n -PSP700
.\"
.\" Warning: Maybe nroff can't handle it correctly.
.\"
.EH '\fBTest Report\fP''Tgif i18n\fP'
.OH '\fBTest Report\fP''Tgif i18n\fP'
.EF ''\fB % \fP''
.OF ''\fB % \fP''
.ps 11
.nr PS 11
.RP
\&
.sp 8
.ce 100
\s+4\fBINTERNATIONALIZATION\fP\s-4

\s+4\fBOF\fP\s-4

\s+4\fBTGIF\fP\s-4
.ce 0
.sp 6
.ce 1
\s+2\fBContents\fP\s-2
.IP " " 35
.TS
l1 l.
*	Manual(i18n only)
*	Test Report(i18n only)
.TE
.LP
.sp 12
.ce 100
Li Yuhong

Nov. 22, 1991
.ce 0
.bp
\&
.NH 1
Introduction
.PP
This is BRIEF test report of internationalization(i18n) version tgif that is
modified from tgif-2.11, Tgif Version 2.11(patchlevel 2).  In this report
the i18n version is named tgif+i18n, the double letters AA means the
Japanese hiragana A.
.PP
It is better to treat this report as a guide how to input text in
tgif rather than an accurate testing.
.NH
Test Environment
.PP
This test is done on LUNA SX-9100/DT, UniOS-B, and X11R4 or up.
The xwnmo is needed too. And the following environemnets should be
set besides the XNLSPATH and LANG variables:
.sp
.RS
% setenv  TGIFPATH  `pwd`
.br
% setenv  TGIFICON   tgificon
.RE
.NH
Test Case
.PP
Since the modification of tgif-2.11 is mostly in text processing, the test
cases are listed about text only.
.TS
box;
cb s s
c | c | c
ltiw(1i) | ltw(3i) | lw(.5i).
Test Case List
=
Case	Action	Notes
_
T{
1. input English
T}	T{
.br
move cursor over Drawing menu on Choice window
(position (0,0), choiceWindow).
.br
click the middle button to popup a menu, then move cursor to
choose item of "T"(text mode).
.br
move cusor over Font menu on Choice window
(position (1,2), choiceWindow).
.br
click the middle button to popup a menu, then move cursor to
choose item of Times, Courier, Helvetica or NewCentury.
then the mark W is displayed.
.br
put cursor inside Canvas window(drawWindow) at a position.
.br
click the left button to fix it.
.br
hit keys to input English.
T}	The tab key is invalid.
_
T{
2. input Japanese
T}	T{
.br
move cursor over Drawing menu on Choice window
(position (0,0), choiceWindow).
.br
click the middle button to popup a menu, then move cursor to
choose item of "T".
.br
move cusor over Font menu on Choice window
(position (1,2), choiceWindow).
.br
click the middle button to popup a menu, then move cursor to
choose item of Multibyte, then the mark "AA" is displayed.
T}
_
.TE
.bp
.TS
box;
ltiw(1i) | ltw(3i) | lw(.5i).
	T{
.br
suppose xwnmo is running, then do the following steps.
.br
put cursor inside Canvas window(drawWindow) at a position.
.br
click the left button to fix it.
.br
press Ctrl-\(holding control key and press the key \) to
switch to xwnmo.
.br
hit keys to  input Japanese from xwnmo window.
.br
press KAKUTEI key to put Japanese characters on Canvas window.
T}
_
T{
3. insert/delete characters
T}	T{
.br
run 1 or 2 to input some text, and fix Drawing mode to "T".
.br
put cursor between characters inside the text.
.br
click the left button to see insert-point.
.br
run 1 or 2 again to insert characters(printable, newline).
.br
press backspace key to delete characters(printable, newline).
T}
_
T{
4. connect with xwnmo
T}	T{
.br
run xwnmo before tgif runs.
.br
(or run xwnmo during tgif is runing.)
.br
run 1, 2 or 3.
.br
quit xwnmo while xwnmo in sleep mode(prompt is [---]).
.br
run 1, 2 or 3.
.br
run xwnmo again.
.br
run 1, 2 or 3.
.br
quit xwnmo while xwnmo in conversion mode(promt is [AA]).
.br
run 1, 2, or 3.
T}
_
T{
5. text in Multibyte font
T}	T{
.br
run 2 to input Japanese.
.br
press ^\\\\ to make xwnmo in sleep mode(prompt is [---]).
.br
hit alphenumerical keys that should be invalid in Japanese text.
.br
press Control key, i.e.,  ^S to save, that should be valid.
T}
_
T{
6. switch between English and Multibyte font
T}	T{
.br
run 2 to choose Multibyte.
.br
input kanji.
.br
run 1 to choose English.
.br
input English, then
.br
move cursor in to kanji text, continue to input kanji.
.br
and vice versa to try input English again.
.br
quit xwnmo, then try above steps again.
T}
_
.TE
.bp
.TS
box;
ltiw(1i) | ltw(3i) | lw(.5i).
T{
7. output of PostScript
T}	T{
.br
run 1 and 2
.br
move cursor over Output Format menu on Choice window
(position (0,8), choiceWindow).
.br
click the left button to change output format to PostScript,
the mark "ps" should be dislayed.
.br
press ^P to printing out the PS file.
T}
_
T{
8. output of LaTeX
T}	T{
.br
run 7
.br
but click the left button to change output format to LaTex,
the mark "LaTeX" should be displayed.
.br
press ^P to printing out the LaTeX file.
.sp2
Please note that the main differency of PS and LaTeX format is that
the PS file has one more line of "show page" than
LaTeX.
T}
_
.TE
.NH
An Exmaple
.PP
The next page is an example that is firstly generated to a PostScript file
with this version of tgif, and then printed out.  The file is exkanji.obj.
